<script>
import {
  defineComponent,
  useContext,
  onMounted,
  ref,
} from '@nuxtjs/composition-api';
import { useShare } from '@vueuse/core';

export default defineComponent({
  name: 'BhShare',
  props: {
    resource: {
      type: Object,
      default: () => ({}),
    },
  },
  setup(props) {
    const { resource } = props;
    const { $config, route } = useContext();

    const options = {
      title: `Biz Hunt - ${resource.title}`,
      text: resource.title,
      url: `${$config.appURL}${route.value.fullPath}`,
    };

    const isShareSupported = ref(false);
    const startShare = ref(() => true);

    onMounted(() => {
      const { isSupported, share } = useShare();

      isShareSupported.value = isSupported;
      startShare.value = () =>
        share(options).catch((e) => console.error({ error: e.message }));
    });

    return {
      isShareSupported,
      startShare,
    };
  },
});
</script>

<template>
  <div v-if="isShareSupported">
    <bh-share-button-ui @click="startShare" />
  </div>
</template>
